package arm;

import iron.math.Vec4;
import iron.system.Input;
import iron.object.Object;
import armory.trait.physics.PhysicsWorld;
import armory.trait.internal.CameraController;
import armory.trait.physics.RigidBody;
import iron.system.Time;


class Horizontal extends iron.Trait {


	
	var body:RigidBody;
	var lastName = "0";
	@prop
    public var goingRight: Bool = true;
	@prop
	public var speed = 3.0;

	public function new() {
		super();

		notifyOnInit(function() {
			body = object.getTrait(RigidBody);
			body.notifyOnContact(function(body2:RigidBody) {
				var thing = body2.object;
				var marco = thing.getTrait(Alternar);
				if(marco != null){
					trace(thing.name);
					if(thing.name != lastName){
						lastName = thing.name;
						goingRight = !goingRight;
					}
				}
			});
		});

		notifyOnUpdate(function() {
			if(goingRight){
				object.transform.translate(0.0, (speed * Time.delta), 0.0);
				
			}else{
				object.transform.translate(0.0, ((speed * Time.delta)* -1), 0.0);
			}
			body.syncTransform();
			object.transform.buildMatrix();
		});

		// notifyOnRemove(function() {
		// });
	}
}
